#ifndef CXMLMANAGER_HH
#define CXMLMANAGER_HH

#include <string>

struct _xmlDoc;
typedef _xmlDoc* xmlDocPtr;

struct _xmlXPathContext;
typedef _xmlXPathContext* xmlXPathContextPtr;

class CXmlManager
{
public:
  CXmlManager();
  ~CXmlManager();

public:
  //able to treat only one file at the same time
  int OpenFile(const char* filename);
  int OpenFile(std::string filename){
    return OpenFile(filename.c_str());
  }
  //double, int, and std::string is explicitly instanted 
  template <class ValueType>
  int GetValue(const char* xpathExpr, ValueType* value);
  template <class ValueType>
  int GetValue(std::string xpathExpr, ValueType* value){
    return GetValue(xpathExpr.c_str(), value);
  }
  
private:
  int CloseFile();

  xmlDocPtr doc;
  xmlXPathContextPtr xpathCtx; 
};

#endif
