
#include "TROOT.h"

#include "CCoordinateTransformation.hh"

ClassImp(CCoordinateTransformation)

CCoordinateTransformation::CCoordinateTransformation
(double xorigin, double yorigin, double theta)
: m_xorigin(xorigin), m_yorigin(yorigin), m_cos(cos(theta)), m_sin(sin(theta))
{;}

CCoordinateTransformation::~CCoordinateTransformation()
{;}

void CCoordinateTransformation::Go
(double x, double y, double& xprime, double& yprime)
{
  double xtemp = x-m_xorigin;
  double ytemp = y-m_yorigin;
  xprime = m_cos*xtemp + m_sin*ytemp;
  yprime = -m_sin*xtemp + m_cos*ytemp;
}

void CCoordinateTransformation::Return
(double xprime, double yprime, double& x, double& y)
{
  double xtemp = m_cos*xprime - m_sin*yprime;
  double ytemp = m_sin*xprime + m_cos*yprime;
  x = xtemp+m_xorigin;
  y = ytemp+m_yorigin;
}

double CCoordinateTransformation::GoX(double x, double y)
{
  double xprime, yprime;
  Go(x, y, xprime, yprime);
  return xprime;
}

double CCoordinateTransformation::GoY(double x, double y)
{
  double xprime, yprime;
  Go(x, y, xprime, yprime);
  return yprime;
}

double CCoordinateTransformation::ReturnX(double xprime, double yprime)
{
  double x, y;
  Return(xprime, yprime, x, y);
  return x;
}

double CCoordinateTransformation::ReturnY(double xprime, double yprime)
{
  double x, y;
  Return(xprime, yprime, x, y);
  return y;
}
