
#include <cmath>
#include <cstring>

#include "FFunction.hh"
#include "CFold.hh"
#include "TF1.h"

ClassImp(CFold)

CFold::CFold(TF1* fold)
{
  fFold = fold;
  SetStep(0.01);

  Double_t xmin, xmax;
  fFold->GetRange(xmin, xmax);
  Int_t npar = fFold->GetNumberFreeParameters();
  fFolded = new TF1("cfold", this, &CFold::Evaluate, xmin, xmax, npar);
  fFolded->SetParameters(fFold->GetParameters());
}

CFold::~CFold()
{;}

void CFold::SetStep(Double_t step)
{
  fStep = step;
}

TF1* CFold::GetFoldedFunction()
{
  return fFolded;
}
