
#include <cmath>
#include <cstring>

#include "FFunction.hh"
#include "CFoldHIME.hh"
#include "TF1.h"

ClassImp(CFoldHIME)

CFoldHIME::CFoldHIME(TF1* fold) : CFold(fold)
{
  Double_t xmin, xmax;
  fFold->GetRange(xmin, xmax);
  fPoisson  = new TF1("poisson",  Poisson,  xmin, xmax, 3);
}

CFoldHIME::~CFoldHIME()
{
  delete fPoisson;
}

Double_t CFoldHIME::Evaluate(Double_t* x, Double_t* par)
{
  fFold->SetParameters(par);

  Double_t xmin, xmax;
  fFold->GetRange(xmin, xmax);
  Double_t sum = 0;
  for(Double_t xx = xmin; xx < xmax; xx += fStep){

    // 250MeV 10m 1g
    //    Double_t k = -50.6*xx+133;
    //    Double_t lambda = 110*xx+2.34;
    // 250MeV 9m 1g
    Double_t k = -47.1*xx+122;
    Double_t lambda = 98.1*xx+2.43;
    // 100MeV 4.6m 0.42g lneut
    //    Double_t k = -8.8*xx+36;
    //    Double_t lambda = 30.2*xx+1.58;
    fPoisson->SetParameters(1, k, lambda);
    Double_t g = fPoisson->Eval(x[0]);

    Double_t f = fFold->Eval(xx);

    sum += f*g*fStep;
  }

  return sum;
}

