#ifndef ANALYZETOOL_HH
#define ANALYZETOOL_HH

#include "TROOT.h"

#include <string>

#include "CParticle.hh"

class TVector3;
class TCanvas;
class TDirectory;
class TFile;
class TH1D;
class TH2D;
class TH3D;

class CDataHime;
class CDataHimeSim;
class CParticle;

class CAnalyzeTool
{
public:
  CAnalyzeTool(){;}
  ~CAnalyzeTool(){;}

  static int GetFirstProtonInformation(CDataHimeSim* data, CParticle* proton);
  static double GetTotalEnergyLoss(CDataHime* data);
  static void FoldChargedParticle(TVector3 momentum, CParticle* particle,
			   TVector3 dpoverp, double dele, double estrag, double multi_theta
);

  static double c;

  ClassDef(CAnalyzeTool, 0)
};

#endif
